function architecture
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%This function simply sets up parameters used by the model.




global BIAS INHIB LEAK DT_VM EE EI EL GAMMA THETA TIMESTEP NUMLAYERS NUMNEURONS NUMLAGS LAGLENGTH ITEMLENGTH NUMWM TDU TDUWEIGHT STARTVAL TEMPDELTATHRESH KNOCKOUTTHRESH PERMTHRESH TEMPRATE PERMRATE NUMSTREAMS NUMITEMS RESLIMIT VARIANCE BASE RESWEIGHT NUMINPUTS THETA2 WIPELAYER
global Neurons Axons  Inputvector Retina Weightcount Weightlist Axonindex LearnItemDelta LearnItem TempWeight TempWeightDelta
global History MPHistory OutHistory InHistory BiasHistory ExHistory
global BASICRSVP WMBIAS NUMNEURONSBYLAYER  Weightindex CONFLICT TRIALDISTRIBUTION REALSTARTVAL BIASVARIANCE 
global Weightcount Weightparams NUMSTEPS colornaming GAMMA2

Weightcount = 0;
Weightparams = 0;


%environment set up
%**************************************************************************
%parameters

%Number of working memory slots that we'll bother computing 
%(to save time)
NUMWM = 0;
NUMLAYERS = 13;   % number of layers in the network

%number of possible items in the RSVP stream    
NUMITEMS = 7;


NUMNEURONS = NUMITEMS;    
NUMINPUTS = NUMITEMS;
NUMNEURONSBYLAYER  = [NUMINPUTS, NUMINPUTS,NUMINPUTS, NUMINPUTS,1,1,NUMITEMS,1,1,1,3,1,1];



%generic parameters
BIAS(1:NUMLAYERS) = 0;


%color naming
BIAS(3) = -1;
BIAS(4) = -1;
BIAS(6) = -1;
BIAS(5) = -1;
BIAS(7) = -1;
BIAS(11) = -2;
BIAS(13) = -1;
%word naming
%BIAS(6) = .01;



BIAS(10) = 0;
%BIAS(7) = -.045;

BIASVARIANCE(1:NUMLAYERS) = 1;
%strength of a layer's feedback inhibition
INHIB(1:NUMLAYERS) = 0;  %obsolete

%leak current strength
LEAK(1:NUMLAYERS) = .04;

%LEAK(8) = .1;
%LEAK(13) = .1;


%rate of change parameter, how fast does the neuron's memb_pot approach its
%steady state value
DT_VM(1:NUMLAYERS) = .15;
DT_VM(11) = .003;

DT_VM(5) = .002;
DT_VM(6) = .002;
DT_VM(13) = .02;
DT_VM(10) = .02;


%excitatory, inhibitory and Leak reversal potentials.  
EE(1:NUMLAYERS) = 2;
EI(1:NUMLAYERS) = .1;
EL(1:NUMLAYERS) = .2;

% Gamma controls the shape of the neurons' output functions
% Theta is the threshold
GAMMA(1:NUMLAYERS) =3;
GAMMA2(1:NUMLAYERS) =3; 
GAMMA2(5:6) = 100;   % for taskdemand projection to 7, drops off quickly.  

%GAMMA(4) = 15; 
THETA(1:NUMLAYERS) = 0;
THETA(5) = 0;
THETA(6) = 0;

THETA2(1:NUMLAYERS) = 1;  %for 7... high threshold
THETA2(5)= -.065;        %for task demand projection to 7, highly saturated
THETA2(6) =-.12;     %this value is subtracted, so this is really adding

%THETA2(5) = .6;

TIMESTEP = 5;  %millisec

%membrane potentials at timestep 1.
STARTVAL(1:NUMLAYERS) = .2;

STARTVAL(1:8) = 0;


%Color naming
if(colornaming)
    STARTVAL(5) = -.025;
    STARTVAL(6) = -1.96;
    STARTVAL(10) = -.013;
    STARTVAL(13) = -1.45;
    
else
    STARTVAL(6) = -.034;
    STARTVAL(5) = -1.95;
    STARTVAL(10) = -.018;
    STARTVAL(13) = -1.32;
end

STARTVAL(3) = -1;
STARTVAL(4) = -1;
STARTVAL(7) = -1;
STARTVAL(11) = -1;




%layer specific parameters

STARTVAL(1:2) = 0;

REALSTARTVAL = STARTVAL;

% STARTVAL(5) = .2;
% STARTVAL(6) = .3;
% STARTVAL(8) = .35;

CONFLICT = 40;


%**************************************************************************
%network structure

Neurons = zeros(NUMLAYERS,NUMINPUTS);  %equiv to membpot

%connectivity is strictly hierarchical, going from layer X to layer X +1
Axons = zeros(NUMLAYERS+1,NUMINPUTS,NUMINPUTS);    %obsolete

%(source, dest,type)
%type 1 = one to one
%type 2 = all to all
%type 3 = notched inhib
%type 4 = flat lateral inhib
weightset = zeros(NUMLAYERS,NUMLAYERS,4);

%basic structure


inkweight =1;
wordweight = inkweight*3.5;
% Em =  inkweight*1.3;
% Neut = inkweight*1.3;



upweight = 1;

weightset(1,3,1) = upweight;
weightset(2,4,1) = upweight;

weightset(4,7,1) = wordweight;
weightset(3,7,1) = inkweight;

responseweight =6;
weightset(7,11,1) = responseweight;


weightset(4,13,2) = .000000001;  %these are placeholders, the real connection for the emotion monitor is down below,  7,3 to 12,1

%input to the emotional acc
%weightset(12,13,2) = .4;  

%TDU

%originall .51

factor = 1;   % for 5,6 theta1
factor2 = .5263  %for 5 out to 7  (theta2) 
tweight =.5 * factor ;

weightset(5,3,2) = tweight;
weightset(6,4,2) = tweight;

weightset(5,4,2) = -tweight*2;
weightset(6,3,2) = -tweight*2;

%task demand bias
weightset(5,7,2) =.00000001;
weightset(6,7,2) =.00000001;

%TMU for state anxiety
weightset(8,3,2) =.00000001;
weightset(8,4,2) =.00000001;

%originally 2

weightset(5,6,1) = -2*factor;
weightset(6,5,1) = -2*factor;

%WTA 
laterali = -3;

weightset(7,7,3) = laterali;

laterali = -5;
weightset(11,11,3) = laterali;


%conflict monitoring and feedback

%color naming
if(colornaming)
    weightset(10,5,1) =2;
else
    weightset(10,6,1) =2 ;
end

weightset(13,10,1) = -1;
weightset(10,13,1) =-1;

weighttype = zeros(NUMLAYERS,NUMLAYERS,4);


weightsat = ones(NUMLAYERS,NUMLAYERS,4);

%weightsat(5,7,2) = .5;
%weightsat(4,13,2) = .3;
weightstp = zeros(NUMLAYERS,NUMLAYERS,4,5);
%weightstp(8,4,2,1) = .3;  %pre thresh
%weightstp(8,4,2,2) = .3;  %post thresh
%weightstp(8,4,2,3) = 30;    %max
%weightstp(8,4,2,4) = 1;    %increase rate
%weightstp(8,4,2,5) = .999;    %decay rate

weightthresh= ones(NUMLAYERS,NUMLAYERS,4);


%special settings
%weightsat(5,7,2) = 2;  %  if weightsat is > 1,  chooses a different GAMMA for sigmoid
%weightsat(6,7,2) = 2;


weightthresh(7,7,3)= 2;
weightthresh(5,7,2)= 2;
weightthresh(6,7,2)= 2;
% weightthresh(5,3,2)= 2;
% weightthresh(5,4,2)= 2;
% weightthresh(6,3,2)= 2;
% weightthresh(6,4,2)= 2;
% weightthresh(5,3,2)= 2;
% weightthresh(6,4,2)= 2;

sprintf('Generating Weight list');
%now generate the list of weights
Weightlist = 0;
Weightcount = 0;
for(layer= 1:NUMLAYERS)
    for(layer2 = 1:NUMLAYERS)
        for(type = 1 :4)            
            if(weightset(layer,layer2,type) ~= 0) %we got one
                %                sprintf('entering loop for %d %d',layer,layer2)
                for(i = 1:NUMNEURONSBYLAYER(layer))
                    for(j = 1:NUMNEURONSBYLAYER(layer2))
                        switch(type)
                            case 1   %id matrix
                                if(i == j)
                                    AddWeight(layer,layer2,i,j,weightset(layer,layer2,type),weighttype(layer,layer2,type),weightsat(layer,layer2,type),weightstp(layer,layer2,type,:),weightthresh(layer,layer2,type),0);
                                end
                            case 2             %all to all                   
                                AddWeight(layer,layer2,i,j,weightset(layer,layer2,type),weighttype(layer,layer2,type),weightsat(layer,layer2,type),weightstp(layer,layer2,type,:),weightthresh(layer,layer2,type),0);
                            case 3      %notched all to all
                                
                                if(j ~= i)
                                    AddWeight(layer,layer2,i,j,weightset(layer,layer2,type),weighttype(layer,layer2,type),weightsat(layer,layer2,type),weightstp(layer,layer2,type,:),weightthresh(layer,layer2,type),0);                    
                                end
                            case 4        %all to all inhibition
                                if(j ==1)  %this j will be ignored anyway
                                    AddWeight(layer,layer2,i,j,weightset(layer,layer2,type),weighttype(layer,layer2,type),weightsat(layer,layer2,type),weightstp(layer,layer2,type,:),weightthresh(layer,layer2,type),0);
                                end
                        end  %switch
                    end  %for j
                end  %for i
            end  %if
        end  %for type
    end  %for layer2 
end  %for layer1




%emotional activation of emotional ACC
Em = 1.7;
if(colornaming)

     % emotional ACC
    neutweight = Weightindex(4,13,6,1);
    Weightparams(neutweight,5) = Em;
    neutweight = Weightindex(4,13,7,1);
    Weightparams(neutweight,5) = Em;
    
    stateweight = Weightindex(8,4,1,6);
    traitweight = Weightindex(4,7,6,6);
else
  
    neutweight = Weightindex(4,13,2,1);
    Weightparams(neutweight,5) = Em;
    stateweight = Weightindex(8,4,1,2);
    traitweight = Weightindex(4,7,2,2);
end


%reduction in inhibitory control   STATE ANXIETY
state = .1;
state = .000001;
Weightparams(stateweight,5) =state;

%TRAIT ANXIETY 
trait = 1;
%trait = 1.6;
Weightparams(traitweight,5) =Weightparams(traitweight,5) *trait;

  



Em = 1.2 * factor2; 
if(colornaming)
  
    neutweight = Weightindex(5,7,1,1);
    Weightparams(neutweight,5) = Em;
    neutweight = Weightindex(5,7,1,2);
    Weightparams(neutweight,5) = Em;
% semantic Weight...   
    neutweight = Weightindex(5,7,1,4);
%    Weightparams(neutweight,5) = Em;
   
    
else
  
    neutweight = Weightindex(6,7,1,1);
    Weightparams(neutweight,5) = Em;
    neutweight = Weightindex(6,7,1,2);
    Weightparams(neutweight,5) = Em;
    neutweight = Weightindex(6,7,1,3);
    Weightparams(neutweight,5) = Em;
    neutweight = Weightindex(6,7,1,4);
    Weightparams(neutweight,5) = Em;
    neutweight = Weightindex(6,7,1,5);
    Weightparams(neutweight,5) = Em;
    neutweight = Weightindex(6,7,1,6);
    Weightparams(neutweight,5) = Em;
end







%emoweight = Weightindex(7,4,4,4)
%Weightparams(emoweight,5) = Em;
%neutweight = Weightindex(7,4,3,3);
%Weightparams(neutweight,5) = Neut;
%neutweight = Weightindex(7,12,4,1);
%Weightparams(neutweight,5) = .3;
%neutweight = Weightindex(4,12,4,1);
%Weightparams(neutweight,5) = .3;



sprintf('Total of %d weights created',Weightcount);

%**************************************************************************
%input patterns  12 lags per rsvp

%how many Streams (lags) to run?
NUMSTREAMS = 20;

WIPELAYER = ones(NUMSTREAMS,NUMLAYERS);
WIPELAYER(:,5:6) = 0;   %don't nuke the biases, not worth the time
WIPELAYER(:,8) = 0;     % don't nuke the 2 halves of the ACC either
WIPELAYER(:,13) = 0;
WIPELAYER(:,10) = 0;




%SOA 100 msec, 50 msec on, 50 msec blank.
LAGLENGTH = 100; %msec
ITEMLENGTH =100; %msec

NUMSTEPS = 20;

%Basic paradigm
if(size(BASICRSVP,1)< NUMSTREAMS)    
    BASICRSVP = zeros(NUMSTREAMS,NUMSTEPS,7);
end



% script to initialize the variables.
%inputpatterns;


%**************************************************************************    
% Working memory
%OBSOLETE
%hebbian weights 
LearnItem = zeros(NUMNEURONS/2,NUMWM);
LearnItemDelta = zeros(NUMNEURONS/2,NUMWM);

%threshold for Hebbian plasticity
PERMTHRESH = .2;  %cat neuron output has to be > than this.  

%rate of change
PERMRATE = .4;



%**************************************************************************    
% Task Demand Unit

%this adds a bias to category elements 1 and 2 and an inhibitory bias to
%all other items.  
TDU(1:NUMNEURONS)  = 0;
TDU(1:2) = .6;
TDU(3:NUMITEMS) = .1;
TDUWEIGHT = 0;





%**************************************************************************    
% Batch processing



VARIANCE  = 0;
BASE = 1;  
%DISTRIBUTION = UNIFORM;

%cong incong neutral emo






function AddWeight(lay1,lay2,i,j,val,weighttype,weightsat,stp,thresh,hook)

global Weightcount Weightparams Weightindex



Weightcount = Weightcount + 1;          
Weightindex(lay1,lay2,i,j) = Weightcount;
Weightparams(Weightcount,1) =  lay1;
Weightparams(Weightcount,2) =  lay2;
Weightparams(Weightcount,3) =  i;
Weightparams(Weightcount,4) =  j;             
Weightparams(Weightcount,5) =  val;
Weightparams(Weightcount,6) =  weighttype;
Weightparams(Weightcount,7) =  weightsat;
Weightparams(Weightcount,8) =  1;   %HEB!
Weightparams(Weightcount,9) =  stp(1,1,1,1);   %HEB!  pre
Weightparams(Weightcount,10) =  stp(1,1,1,2);   %HEB!   post
Weightparams(Weightcount,11) =  stp(1,1,1,3);   %HEB!    max
if(j < 3)  %hack to limit number of stp calculations
    Weightparams(Weightcount,12) =  stp(1,1,1,4);   %HEB!    increaserate
end
Weightparams(Weightcount,13) =  stp(1,1,1,5);   %HEB!    decay rate
Weightparams(Weightcount,14) =  thresh;   % secondary threshold
Weightparams(Weightcount,15) = hook;

